package TableNested;

import Table.Entry;

import java.util.ArrayList;

/**
 * All you need to do for this microlab is take the Table and Entry from the last one and make Entry a nested class.
 * Think about how nested classes should work with generics.
 */
public class TableNested<K, V> {
    private ArrayList<Entry> entries;

    public TableNested() {
        this.entries = new ArrayList();
    }


    public class Entry<K, V> {
        private K key;
        private V value;

        public Entry(K key, V value) {
            this.key = key;
            this.value = value;
        }

        public void setKey(K key) {
            this.key = key;
        }

        public void setValue(V value) {
            this.value = value;
        }

        public K getKey() {
            return key;
        }

        public V getValue() {
            return value;
        }

    }


    public V get(K foo) {
        for (Entry e : entries) {
            if (e.getKey().equals(foo)) {
                return (V) e.getValue();

            }
        }
        return null;
    }

    public void put(K foo, V i) {
        for (Entry e : entries) {
            e.setKey(foo);
            e.setValue(i);
        }

        entries.add(new Entry(foo, i));
    }

    public void remove(K foo) {
        for (Entry e : entries) {
            if (foo.equals(e.getKey())) {
                entries.remove(e);
                return;
            }
        }
    }
}
